# $Id: uploadresource.py,v 1.48 2011/05/13 11:43:04 irees Exp $
import re
import os
import pickle
import traceback
import time
import random
import cStringIO
import urllib
import emen2.util.jsonutil

# emen2 imports
import emen2.web.resources.emen2resource
import emen2.util.loganalyzer
import emen2.db.config
g = emen2.db.config.g()

import emen2.web.thumbs



class UploadResource(emen2.web.resources.emen2resource.EMEN2Resource):

	resourcename = 'upload'

	# Look for filename; if PUT, add a reference to the request.content file handle.
	def parse_content(self, request):
		postargs = {}

		if request.getHeader('X-Filename'):
			postargs['filename'] = request.getHeader('X-Filename')

		if request.method == "POST":
			request.content.seek(0)
			content = request.content.read()
			b = re.compile("filename=\"(.+)\"")
			try:
				postargs['filename'] = b.findall(content[:1000])[0]
			except:
				pass

		elif request.method == "PUT":
			postargs['infile'] = request.content

		return postargs


	def _action(self, args=None, ctxid=None, host=None, db=None, request=None):
		infile = args.get('infile') or args.get('filedata')
		param = args.get('param', 'file_binary')
		filename = args.get('filename', '').split("/")[-1].split("\\")[-1]
		
		if args.get('newrecord'):
			args['record'] = args['newrecord']
			
		if args.get('record'):
			try:
				record = emen2.util.jsonutil.decode(urllib.unquote(args.get('record')))
			except ValueError, e:
				raise ValueError, "Invalid JSON record: %s"%e
		else:
			try:				
				record = int(request.postpath[0])
			except (IndexError, TypeError, ValueError):
				# raise ValueError, "No Record name specified for upload"
				record = None

		# Action
		db._starttxn(write=True)
		with db:
			db._setContext(ctxid, host)
			bdo = db.putbinary(None, filename=filename, record=record, infile=infile, param=param)

		# Redirect..
		headers = {}
		location = args.get("Location") or args.get("location")
		if location:
			headers['Location'] = location
		headers['X-Resource'] = 'upload'

		emen2.web.thumbs.run_from_bdo(bdo, wait=False)

		# Return the BDO
		return emen2.util.jsonutil.encode(bdo).encode("utf-8"), headers



__version__ = "$Revision: 1.48 $".split(":")[1][:-1].strip()
